
use Northwind
go

exec sp_helpindex 'dbo.orders'

-- all statistics in current database
exec sp_updatestats 

select t.name, * from sys.stats s
join sys.tables t
on t.object_id = s.object_id

-- dbcc show_statistics('table', 'stat')
dbcc show_statistics ('dbo.orders', 'orderdate')

/*
To Estimate cardinality:
1. RangeHighKey - best
2. AVG_RANGE_ROWS
3. Density of entire column
4. Hardcoded guess
*/

-- estimate 12
select orderdate, orderdate from orders
where orderdate between '19960708' and '19960719' and (1=1)

-- estimate 6.745
select orderdate, orderdate from orders
where orderdate between '19960709' and '19960718' and (1=1)

-- estimate 2.06
select orderdate, orderdate from orders
where orderdate between '19960710' and '19960711' and (1=1)

-- estimate 1, actual 3
select orderdate, orderdate from orders
where orderdate between '19971212' and '19971215' and (1=1)

-- exact, can use range_hi_key, estimate = actual = 676
select orderdate, orderdate from orders
where orderdate > '19970101'

-- no range_hi_key, uses avg_range_rows
select orderdate, orderdate from orders
where orderdate = '19970414'

dbcc freeproccache

-- estimate 249, actual 676
declare @orderdate date = '19970101'
select orderdate, orderdate from orders
where orderdate > @orderdate

dbcc freeproccache

-- estimate 1.72, actual 2 (density or guess)
declare @orderdate datetime = '19970226'
select orderdate, orderdate from orders
where orderdate = @orderdate

dbcc freeproccache

-- same estimate, actual 6 (same density or guess)
declare @orderdate datetime = '19980226'
select orderdate, orderdate from orders
where orderdate = @orderdate

use pubs
go

select t.name, * from sys.stats s
join sys.tables t
on t.object_id = s.object_id
where t.name = 'authors'

dbcc show_statistics ('dbo.authors', 'aunmind')
go

-- cause auto-stat creation
select * from authors where city='Oakland'
go

select t.name, * from sys.stats s
join sys.tables t
on t.object_id = s.object_id
where t.name = 'authors'

dbcc show_statistics ('dbo.authors', '_WA_Sys_00000006_7E6CC920')
go

select distinct city from dbo.authors

-- add 'and 1=1' to prevent autoparameterization
select * from authors where city = 'Oakland' and 1 = 1
-- or free the whole proc cache (test system)
dbcc freeproccache
select * from authors where city = 'Nashville' and 1 = 1